package com.agilecontrol.nea.core.web.shell;

import com.agilecontrol.nea.core.control.web.WebUtils;
import com.agilecontrol.nea.core.query.QueryUtils;
import com.agilecontrol.nea.core.report.ReportUtils;
import com.agilecontrol.nea.core.web.shell.AbstractShellCmd;
import com.agilecontrol.nea.core.web.shell.Shell;
import com.agilecontrol.nea.util.CommandExecuter;
import com.agilecontrol.nea.util.NDSException;
import com.agilecontrol.nea.util.Tools;
import com.agilecontrol.nea.util.Validator;
import java.io.File;
import java.text.DecimalFormat;
import java.text.SimpleDateFormat;
import java.util.Date;
import javax.servlet.http.HttpServletRequest;
import org.json.JSONObject;

@Shell(
   alias = "sh",
   admin = true,
   help = "sh command, 执行服务器上的操作系统命令,需要是管理员"
)
public class ExecShell extends AbstractShellCmd {

   protected JSONObject process(String args, JSONObject envObj) throws Exception {
      if(Validator.isNull(args)) {
         throw new NDSException("@cmd-argument-error@: empty command");
      } else {
         JSONObject jo = null;
         jo = new JSONObject();
         long startTime = System.currentTimeMillis();
         HttpServletRequest request = (HttpServletRequest)envObj.get("request");
         ReportUtils ru = new ReportUtils(request);
         String name = ru.getUserName();
         String svrPath = ru.getExportRootPath() + File.separator + ru.getUser().getClientDomain() + File.separator + this.userWeb.getUserId();
         (new StringBuilder()).append(ru.getOracleExportRootPath()).append(File.separator).append(ru.getUser().getClientDomain()).append(File.separator).append(this.userWeb.getUserId()).toString();
         SimpleDateFormat sdf = new SimpleDateFormat("MMddHHmm");
         String fileName = "cmd" + sdf.format(new Date()) + ".txt";
         String filePath = svrPath + File.separator + fileName;
         File file = new File(filePath);
         File svrDir = new File(svrPath);
         if(!svrDir.isDirectory()) {
            svrDir.mkdirs();
         }

         boolean retCode = false;

         int retCode1;
         try {
            this.logger.debug("{} > {}", args, filePath);
            CommandExecuter duration = new CommandExecuter(filePath);
            retCode1 = duration.run(args);
         } catch (Throwable var19) {
            this.logger.error("Fail to execute " + args, var19);
            jo.put("code", 0);
            jo.put("message", var19.getMessage());
            return jo;
         }

         String duration1 = ((DecimalFormat)QueryUtils.floatFormatter.get()).format((double)(System.currentTimeMillis() - startTime) / 1000.0D);
         jo.put("code", 0);
         StringBuilder sb = new StringBuilder("Duration " + duration1 + " seconds, exit code ");
         sb.append(retCode1);
         if(file.exists()) {
            sb.append(", output size ").append(Tools.formatSize(file.length())).append(", first lines:<hr>");
            sb.append(this.getFirstLines(file));
            jo.put("fileurl", WebUtils.getServletContext().getContextPath() + "/servlets/binserv/Download?filename=" + fileName);
         }

         jo.put("message", sb.toString());
         return jo;
      }
   }
}
